/*
 * Copyright (C) 2023 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
import { nxE2EPreset } from '@nx/cypress/plugins/cypress-preset';
import { defineConfig } from 'cypress';

const cypressConfig = require('./cypress.config.json');
const cypressEvents = require('./src/support/cypress-tasks.ts');

export default defineConfig({
  e2e: {
    ...nxE2EPreset(__dirname),
    ...cypressConfig,
    setupNodeEvents(on, config) {
      return cypressEvents(on, config);
    },
  },
  // retries: {
  //   experimentalStrategy: 'detect-flake-and-pass-on-threshold',
  //   experimentalOptions: {
  //     maxRetries: 2,
  //     passesRequired: 1,
  //   },
  //   openMode: true,
  //   runMode: true,
  // },
});

export interface CypressConfig {
  baseUrl: string;
  env: Env;
}

export interface Env {
  dbUrl: string;
  database: string;
  userManager: UserManager;
}

export interface UserManager {
  dbUrl: string;
  database: string;
}
